function Rext = comp_Rext(Phi_m, G_lm, G_lm_t, p, r)

%Compute Phi_lm
Phi_lm_temp = mult(G_lm,Phi_m);
Phi_lm = trunc(Phi_lm_temp,p);
%Compute Phi_ml - this can be done without mult-function
Phi_ml = trunc( mult(Phi_m,G_lm_t), p);
%Compute Phi_ll
Phi_ll = trunc( mult( Phi_lm_temp, G_lm_t ), p );
Phi_ll{p+1} = Phi_ll{p+1} + eye(r,r);

for kk=1:p+1,
    Rext{kk} = [
        Phi_m{p+kk}           Phi_ml{p+kk}
        Phi_lm{p+kk}          Phi_ll{p+kk}
    ];
end

end %function

