function [ISDM, G_lm, G_lm_t] = main_loop_causal(K, r, p, Phi_m, G_lm0, G_lm_t0, lam, No_it, causal_latent)

n = K+r;
G_lm = G_lm0;
G_lm_t = G_lm_t0;

for it=1:No_it,
        %Compute extended covariances
        % Rext = comp_Rext_causal(Phi_m, G_lm, G_lm_t, p, r, causal_latent);
        Rext = comp_Rext(Phi_m, G_lm, G_lm_t, p, r);
    
        %Solve (6) 
        ISDM = max_entropy_lam_causal(K, n, p, Rext, lam, causal_latent);
        
         % extract the latent part
    for kk = 0 : p
      G_lm{p+1+kk} = -ISDM{kk+1}(K+1:n,1:K);
    end
    for kk = 1 : p
      G_lm{p+1-kk} = -ISDM{kk+1}(1:K,K+1:n)';
    end
    for kk=1:2*p+1,
      G_lm_t{kk} = G_lm{2*p+2-kk}'; 
    end
end %it

end %function

