function ISDM = second_loop_causal(K, r, p, Phi_m, G_lm, G_lm_t, mask, No_it, causal_latent)

n = K+r;

for it=1:No_it,
    %Compute extended covariances
    Rext = comp_Rext(Phi_m, G_lm, G_lm_t, p, r);
    % Rext = comp_Rext_causal(Phi_m, G_lm, G_lm_t, p, r, causal_latent);
    
    
%      Rext{1}
%      Rext{2}
%      mask
    ISDM = max_entropy_mask_causal(n, K, p, mask, Rext, causal_latent);
%       ISDM{1}
%       ISDM{2}
%      pause
    
    % extract the latent part
    if it<No_it
            for kk = 0 : p,
                G_lm{p+1+kk} = -ISDM{kk+1}(K+1:n,1:K);
            end
            for kk = 1 : p,
                G_lm{p+1-kk} = -ISDM{kk+1}(1:K,K+1:n)';
            end
            for kk=1:2*p+1,
                G_lm_t{kk} = G_lm{2*p+2-kk}'; 
            end
    end
    
end %for

end %function

