function [Phi_m, G_lm0, G_lm_t0] = init_algo(K, p, r, Rest)

%Compute Phi_m
Phi_m{p+1} = Rest{1};
for kk=1:p,
    Phi_m{kk} = Rest{p+2-kk}';
    Phi_m{kk+p+1} = Rest{kk+1};
end
%ME for the manifest part
Q = max_entropy_1(K, p, Rest);
%Init G_lm
for kk=1:2*p+1,
    G_lm0{kk} = zeros(r,K);
end
[U,D] = eig(Q{1});
G_lm0{p+1} = -D(1:r,1:r)^(1/2)*U(1:K,1:r)'; %force a minus
%Compute G_lm_t
for kk=1:2*p+1,
    G_lm_t0{kk} = G_lm0{2*p+2-kk}'; 
end


end %function

